#include "CClipboard.h"

void CClipboard::AttachToClipboard(HWND hWindowAttaching)
{
	m_hAttachedWindow = hWindowAttaching;
	m_hNextInCBChain = SetClipboardViewer(m_hAttachedWindow);
}

void CClipboard::DetachFromClipboard()
{
	ChangeClipboardChain(m_hAttachedWindow, m_hNextInCBChain);
}

void CClipboard::OnChangedCBChain(UINT nMessage, WPARAM wParam, LPARAM lParam)
{
	if ((HWND)wParam == m_hNextInCBChain)
	{
		m_hNextInCBChain = (HWND)lParam;
	}
	else
	{
		SendMessage(m_hNextInCBChain, nMessage, wParam, lParam);
	}
}

/*char* CClipboard::GetClipboardString()
{
	char* pszResult;
	if (OpenClipboard(m_hAttachedWindow))
	{
		if (IsClipboardFormatAvailable(CF_TEXT))
		{
			HANDLE cbdata = GetClipboardData(CF_TEXT);
			if(cbdata)
			{
				LPVOID pData;						
				pData = GlobalLock(cbdata);
				pszResult = (char*) malloc (strlen((char*)pData)*sizeof(char));
				strcpy(pszResult, (char*)pData);
				GlobalUnlock(cbdata);
			}
			else
			{
				pszResult = NULL;
			}			
		}
		CloseClipboard();
	}
	return pszResult;
}*/

void CClipboard::InsertInClipboard(char* pszString)
{
	int nLength = strlen(pszString);
	if (OpenClipboard(m_hAttachedWindow))
	{
		EmptyClipboard();
		HGLOBAL hglCopy = GlobalAlloc(GMEM_MOVEABLE, (nLength + 1) * sizeof(TCHAR)); 
		if (hglCopy)
		{
			LPTSTR lpszCopy;
			lpszCopy = (LPTSTR)GlobalLock(hglCopy); 
			memcpy(lpszCopy, pszString, nLength * sizeof(TCHAR)); 
			lpszCopy[nLength] = (TCHAR)0;
			GlobalUnlock(hglCopy);
			SetClipboardData(CF_TEXT, hglCopy);
		}
		CloseClipboard();
	}
}